Index: /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestsView.cs
===================================================================
--- /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestsView.cs	(revision 11694)
+++ /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestsView.cs	(revision 11695)
@@ -249,6 +249,10 @@
     private void ResetUI() {
       normalityLabel.Image = null;
+      normalityTextLabel.Text = string.Empty;
       groupCompLabel.Image = null;
+      groupComTextLabel.Text = string.Empty;
       pairwiseLabel.Image = null;
+      pairwiseTextLabel.Text = string.Empty;
+
       pValTextBox.Text = string.Empty;
       equalDistsTextBox.Text = string.Empty;
@@ -275,5 +279,6 @@
       if (data.Any(x => x.Length <= requiredSampleSize)) {
         if (showMessage)
-          MessageBox.Show(this, "You need to choose samples with a size greater 5.", "HeuristicLab", MessageBoxButtons.OK,
+          MessageBox.Show(this, "You need at least " + requiredSampleSize
+            + " samples per group for computing hypothesis tests.", "HeuristicLab", MessageBoxButtons.OK,
             MessageBoxIcon.Error);
         return false;
@@ -324,7 +329,13 @@
       pValTextBox.Text = pval.ToString();
       if (pval < significanceLevel) {
-        this.Invoke(new Action(() => { groupCompLabel.Image = HeuristicLab.Analysis.Statistics.Resources.Default; }));
+        this.Invoke(new Action(() => {
+          groupCompLabel.Image = HeuristicLab.Analysis.Statistics.Resources.Default;
+          groupComTextLabel.Text = "There are groups with different distributions";
+        }));
       } else {
-        this.Invoke(new Action(() => { groupCompLabel.Image = HeuristicLab.Common.Resources.VSImageLibrary.Warning; }));
+        this.Invoke(new Action(() => {
+          groupCompLabel.Image = HeuristicLab.Common.Resources.VSImageLibrary.Warning;
+          groupComTextLabel.Text = "Groups have an equal distribution";
+        }));
       }
     }
@@ -341,7 +352,13 @@
       // p-value is below significance level and thus the null hypothesis (data is normally distributed) is rejected. 
       if (res.Any(x => x < significanceLevel)) {
-        this.Invoke(new Action(() => { normalityLabel.Image = HeuristicLab.Common.Resources.VSImageLibrary.Warning; }));
+        this.Invoke(new Action(() => {
+          normalityLabel.Image = HeuristicLab.Common.Resources.VSImageLibrary.Warning;
+          normalityTextLabel.Text = "Some groups may not be normally distributed";
+        }));
       } else {
-        this.Invoke(new Action(() => { normalityLabel.Image = HeuristicLab.Analysis.Statistics.Resources.Default; }));
+        this.Invoke(new Action(() => {
+          normalityLabel.Image = HeuristicLab.Analysis.Statistics.Resources.Default;
+          normalityTextLabel.Text = "All sample data is normally distributed";
+        }));
       }
     }
@@ -389,7 +406,13 @@
 
       if (cnt == 0) {
-        this.Invoke(new Action(() => { pairwiseLabel.Image = HeuristicLab.Analysis.Statistics.Resources.Default; }));
+        this.Invoke(new Action(() => {
+          pairwiseLabel.Image = HeuristicLab.Analysis.Statistics.Resources.Default;
+          pairwiseTextLabel.Text = "All groups have different distributions";
+        }));
       } else {
-        this.Invoke(new Action(() => { pairwiseLabel.Image = HeuristicLab.Common.Resources.VSImageLibrary.Warning; }));
+        this.Invoke(new Action(() => {
+          pairwiseLabel.Image = HeuristicLab.Common.Resources.VSImageLibrary.Warning;
+          pairwiseTextLabel.Text = "Some groups have equal distributions";
+        }));
       }
     }
Index: /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestsView.designer.cs
===================================================================
--- /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestsView.designer.cs	(revision 11694)
+++ /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/StatisticalTestsView.designer.cs	(revision 11695)
@@ -67,5 +67,5 @@
       this.groupCompLabel = new System.Windows.Forms.Label();
       this.normalityGroupBox = new System.Windows.Forms.GroupBox();
-      this.label4 = new System.Windows.Forms.Label();
+      this.normalityTextLabel = new System.Windows.Forms.Label();
       this.normalityStringConvertibleMatrixView = new HeuristicLab.Data.Views.StringConvertibleMatrixView();
       this.normalityLabel = new System.Windows.Forms.Label();
@@ -75,4 +75,6 @@
       this.tabPage2 = new System.Windows.Forms.TabPage();
       this.histogramControl = new HeuristicLab.Analysis.Views.HistogramControl();
+      this.groupComTextLabel = new System.Windows.Forms.Label();
+      this.pairwiseTextLabel = new System.Windows.Forms.Label();
       this.contextMenuStrip1.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).BeginInit();
@@ -95,6 +97,6 @@
       // stringConvertibleMatrixView
       // 
-      this.stringConvertibleMatrixView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
+      this.stringConvertibleMatrixView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.stringConvertibleMatrixView.Caption = "StringConvertibleMatrix View";
@@ -106,5 +108,5 @@
       this.stringConvertibleMatrixView.ShowRowsAndColumnsTextBox = false;
       this.stringConvertibleMatrixView.ShowStatisticalInformation = true;
-      this.stringConvertibleMatrixView.Size = new System.Drawing.Size(567, 523);
+      this.stringConvertibleMatrixView.Size = new System.Drawing.Size(567, 597);
       this.stringConvertibleMatrixView.TabIndex = 0;
       // 
@@ -145,5 +147,5 @@
       // resultComboBox
       // 
-      this.resultComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.resultComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.resultComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
@@ -160,5 +162,5 @@
       this.lblPVal.AutoSize = true;
       this.lblPVal.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
-      this.lblPVal.Location = new System.Drawing.Point(6, 22);
+      this.lblPVal.Location = new System.Drawing.Point(6, 39);
       this.lblPVal.Name = "lblPVal";
       this.lblPVal.Size = new System.Drawing.Size(46, 13);
@@ -169,16 +171,16 @@
       // pValTextBox
       // 
-      this.pValTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.pValTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.pValTextBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
-      this.pValTextBox.Location = new System.Drawing.Point(58, 19);
+      this.pValTextBox.Location = new System.Drawing.Point(58, 36);
       this.pValTextBox.Name = "pValTextBox";
       this.pValTextBox.ReadOnly = true;
-      this.pValTextBox.Size = new System.Drawing.Size(241, 20);
+      this.pValTextBox.Size = new System.Drawing.Size(263, 20);
       this.pValTextBox.TabIndex = 13;
       // 
       // groupComboBox
       // 
-      this.groupComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.groupComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.groupComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
@@ -193,6 +195,6 @@
       // splitContainer1
       // 
-      this.splitContainer1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
+      this.splitContainer1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.splitContainer1.Location = new System.Drawing.Point(6, 19);
@@ -215,6 +217,6 @@
       // splitContainer3
       // 
-      this.splitContainer3.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
+      this.splitContainer3.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.splitContainer3.Location = new System.Drawing.Point(6, 6);
@@ -231,5 +233,5 @@
       this.splitContainer3.Panel2.Controls.Add(this.normalityGroupBox);
       this.splitContainer3.Panel2.Controls.Add(this.selectDataGroupBox);
-      this.splitContainer3.Size = new System.Drawing.Size(910, 529);
+      this.splitContainer3.Size = new System.Drawing.Size(910, 603);
       this.splitContainer3.SplitterDistance = 573;
       this.splitContainer3.TabIndex = 20;
@@ -237,7 +239,8 @@
       // pairwiseTestGroupBox
       // 
-      this.pairwiseTestGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
+      this.pairwiseTestGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.pairwiseTestGroupBox.Controls.Add(this.pairwiseTextLabel);
       this.pairwiseTestGroupBox.Controls.Add(this.pairwiseStringConvertibleMatrixView);
       this.pairwiseTestGroupBox.Controls.Add(this.pairwiseLabel);
@@ -247,7 +250,7 @@
       this.pairwiseTestGroupBox.Controls.Add(this.groupCompComboBox);
       this.pairwiseTestGroupBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
-      this.pairwiseTestGroupBox.Location = new System.Drawing.Point(3, 289);
+      this.pairwiseTestGroupBox.Location = new System.Drawing.Point(3, 306);
       this.pairwiseTestGroupBox.Name = "pairwiseTestGroupBox";
-      this.pairwiseTestGroupBox.Size = new System.Drawing.Size(327, 218);
+      this.pairwiseTestGroupBox.Size = new System.Drawing.Size(327, 275);
       this.pairwiseTestGroupBox.TabIndex = 22;
       this.pairwiseTestGroupBox.TabStop = false;
@@ -256,23 +259,22 @@
       // pairwiseStringConvertibleMatrixView
       // 
-      this.pairwiseStringConvertibleMatrixView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
+      this.pairwiseStringConvertibleMatrixView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.pairwiseStringConvertibleMatrixView.Caption = "StringConvertibleMatrix View";
       this.pairwiseStringConvertibleMatrixView.Content = null;
       this.pairwiseStringConvertibleMatrixView.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
-      this.pairwiseStringConvertibleMatrixView.Location = new System.Drawing.Point(6, 72);
+      this.pairwiseStringConvertibleMatrixView.Location = new System.Drawing.Point(6, 97);
       this.pairwiseStringConvertibleMatrixView.Name = "pairwiseStringConvertibleMatrixView";
       this.pairwiseStringConvertibleMatrixView.ReadOnly = false;
       this.pairwiseStringConvertibleMatrixView.ShowRowsAndColumnsTextBox = false;
       this.pairwiseStringConvertibleMatrixView.ShowStatisticalInformation = false;
-      this.pairwiseStringConvertibleMatrixView.Size = new System.Drawing.Size(315, 140);
+      this.pairwiseStringConvertibleMatrixView.Size = new System.Drawing.Size(315, 172);
       this.pairwiseStringConvertibleMatrixView.TabIndex = 19;
       // 
       // pairwiseLabel
       // 
-      this.pairwiseLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.pairwiseLabel.AutoSize = true;
-      this.pairwiseLabel.Location = new System.Drawing.Point(305, 47);
+      this.pairwiseLabel.Location = new System.Drawing.Point(6, 44);
       this.pairwiseLabel.MaximumSize = new System.Drawing.Size(16, 16);
       this.pairwiseLabel.MinimumSize = new System.Drawing.Size(16, 16);
@@ -285,5 +287,5 @@
       this.label3.AutoSize = true;
       this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
-      this.label3.Location = new System.Drawing.Point(6, 49);
+      this.label3.Location = new System.Drawing.Point(6, 68);
       this.label3.Name = "label3";
       this.label3.Size = new System.Drawing.Size(74, 13);
@@ -294,11 +296,11 @@
       // equalDistsTextBox
       // 
-      this.equalDistsTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.equalDistsTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.equalDistsTextBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
-      this.equalDistsTextBox.Location = new System.Drawing.Point(123, 46);
+      this.equalDistsTextBox.Location = new System.Drawing.Point(86, 65);
       this.equalDistsTextBox.Name = "equalDistsTextBox";
       this.equalDistsTextBox.ReadOnly = true;
-      this.equalDistsTextBox.Size = new System.Drawing.Size(176, 20);
+      this.equalDistsTextBox.Size = new System.Drawing.Size(235, 20);
       this.equalDistsTextBox.TabIndex = 18;
       // 
@@ -315,5 +317,5 @@
       // groupCompComboBox
       // 
-      this.groupCompComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.groupCompComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.groupCompComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
@@ -328,6 +330,7 @@
       // allGroupTestGroupBox
       // 
-      this.allGroupTestGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
+      this.allGroupTestGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.allGroupTestGroupBox.Controls.Add(this.groupComTextLabel);
       this.allGroupTestGroupBox.Controls.Add(this.groupCompLabel);
       this.allGroupTestGroupBox.Controls.Add(this.lblPVal);
@@ -336,5 +339,5 @@
       this.allGroupTestGroupBox.Location = new System.Drawing.Point(3, 237);
       this.allGroupTestGroupBox.Name = "allGroupTestGroupBox";
-      this.allGroupTestGroupBox.Size = new System.Drawing.Size(327, 46);
+      this.allGroupTestGroupBox.Size = new System.Drawing.Size(327, 63);
       this.allGroupTestGroupBox.TabIndex = 21;
       this.allGroupTestGroupBox.TabStop = false;
@@ -343,7 +346,6 @@
       // groupCompLabel
       // 
-      this.groupCompLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.groupCompLabel.AutoSize = true;
-      this.groupCompLabel.Location = new System.Drawing.Point(305, 22);
+      this.groupCompLabel.Location = new System.Drawing.Point(6, 16);
       this.groupCompLabel.MaximumSize = new System.Drawing.Size(16, 16);
       this.groupCompLabel.MinimumSize = new System.Drawing.Size(16, 16);
@@ -354,7 +356,7 @@
       // normalityGroupBox
       // 
-      this.normalityGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.normalityGroupBox.Controls.Add(this.label4);
+      this.normalityGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.normalityGroupBox.Controls.Add(this.normalityTextLabel);
       this.normalityGroupBox.Controls.Add(this.normalityStringConvertibleMatrixView);
       this.normalityGroupBox.Controls.Add(this.normalityLabel);
@@ -367,18 +369,18 @@
       this.normalityGroupBox.Text = "2. Jarque-Bera Test for Normal Distribution";
       // 
-      // label4
-      // 
-      this.label4.AutoSize = true;
-      this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
-      this.label4.Location = new System.Drawing.Point(6, 16);
-      this.label4.Name = "label4";
-      this.label4.Size = new System.Drawing.Size(135, 13);
-      this.label4.TabIndex = 18;
-      this.label4.Text = "Data is normally distributed:";
+      // normalityTextLabel
+      // 
+      this.normalityTextLabel.AutoSize = true;
+      this.normalityTextLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
+      this.normalityTextLabel.Location = new System.Drawing.Point(28, 16);
+      this.normalityTextLabel.Name = "normalityTextLabel";
+      this.normalityTextLabel.Size = new System.Drawing.Size(135, 13);
+      this.normalityTextLabel.TabIndex = 18;
+      this.normalityTextLabel.Text = "Data is normally distributed:";
       // 
       // normalityStringConvertibleMatrixView
       // 
-      this.normalityStringConvertibleMatrixView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
+      this.normalityStringConvertibleMatrixView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.normalityStringConvertibleMatrixView.Caption = "StringConvertibleMatrix View";
@@ -396,5 +398,5 @@
       // 
       this.normalityLabel.AutoSize = true;
-      this.normalityLabel.Location = new System.Drawing.Point(156, 16);
+      this.normalityLabel.Location = new System.Drawing.Point(6, 16);
       this.normalityLabel.MaximumSize = new System.Drawing.Size(16, 16);
       this.normalityLabel.MinimumSize = new System.Drawing.Size(16, 16);
@@ -405,5 +407,5 @@
       // selectDataGroupBox
       // 
-      this.selectDataGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.selectDataGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.selectDataGroupBox.Controls.Add(this.splitContainer1);
@@ -418,6 +420,6 @@
       // tabControl
       // 
-      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
+      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.tabControl.Controls.Add(this.tabPage1);
@@ -426,5 +428,5 @@
       this.tabControl.Name = "tabControl";
       this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(930, 567);
+      this.tabControl.Size = new System.Drawing.Size(930, 641);
       this.tabControl.TabIndex = 21;
       // 
@@ -435,5 +437,5 @@
       this.tabPage1.Name = "tabPage1";
       this.tabPage1.Padding = new System.Windows.Forms.Padding(3);
-      this.tabPage1.Size = new System.Drawing.Size(922, 541);
+      this.tabPage1.Size = new System.Drawing.Size(922, 615);
       this.tabPage1.TabIndex = 0;
       this.tabPage1.Text = "Tests";
@@ -451,19 +453,45 @@
       this.tabPage2.UseVisualStyleBackColor = true;
       // 
-      // dataTableView
-      // 
-      this.histogramControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
+      // histogramControl
+      // 
+      this.histogramControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.histogramControl.CalculateExactBins = false;
+      this.histogramControl.IncrementNumberOfBins = 1;
       this.histogramControl.Location = new System.Drawing.Point(6, 6);
-      this.histogramControl.Name = "dataTableView";
+      this.histogramControl.MaximumNumberOfBins = 100000;
+      this.histogramControl.MinimumNumberOfBins = 1;
+      this.histogramControl.Name = "histogramControl";
+      this.histogramControl.NumberOfBins = 10;
+      this.histogramControl.ShowExactCheckbox = false;
       this.histogramControl.Size = new System.Drawing.Size(910, 529);
       this.histogramControl.TabIndex = 0;
       // 
-      // StatisticalTestingView
+      // groupComTextLabel
+      // 
+      this.groupComTextLabel.AutoSize = true;
+      this.groupComTextLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
+      this.groupComTextLabel.Location = new System.Drawing.Point(28, 16);
+      this.groupComTextLabel.Name = "groupComTextLabel";
+      this.groupComTextLabel.Size = new System.Drawing.Size(165, 13);
+      this.groupComTextLabel.TabIndex = 19;
+      this.groupComTextLabel.Text = "Groups have different distribution:";
+      // 
+      // pairwiseTextLabel
+      // 
+      this.pairwiseTextLabel.AutoSize = true;
+      this.pairwiseTextLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
+      this.pairwiseTextLabel.Location = new System.Drawing.Point(28, 46);
+      this.pairwiseTextLabel.Name = "pairwiseTextLabel";
+      this.pairwiseTextLabel.Size = new System.Drawing.Size(165, 13);
+      this.pairwiseTextLabel.TabIndex = 20;
+      this.pairwiseTextLabel.Text = "Groups have different distribution:";
+      // 
+      // StatisticalTestsView
       // 
       this.Controls.Add(this.tabControl);
       this.Name = "StatisticalTestsView";
-      this.Size = new System.Drawing.Size(936, 573);
+      this.Size = new System.Drawing.Size(936, 647);
       this.contextMenuStrip1.ResumeLayout(false);
       this.splitContainer1.Panel1.ResumeLayout(false);
@@ -516,9 +544,11 @@
     private Data.Views.StringConvertibleMatrixView normalityStringConvertibleMatrixView;
     private Data.Views.StringConvertibleMatrixView pairwiseStringConvertibleMatrixView;
-    private System.Windows.Forms.Label label4;
+    private System.Windows.Forms.Label normalityTextLabel;
     private System.Windows.Forms.TabControl tabControl;
     private System.Windows.Forms.TabPage tabPage1;
     private System.Windows.Forms.TabPage tabPage2;
     private HeuristicLab.Analysis.Views.HistogramControl histogramControl;
+    private System.Windows.Forms.Label pairwiseTextLabel;
+    private System.Windows.Forms.Label groupComTextLabel;
   }
 }